Subject: Re: [bug#47350] [PATCH 00/29] Add Zygote (piece for Machine Learning with Julia)

From: Nicolò Balzarotti <[email-masked]>
Date: Thu, 25 Mar 2021 10:47:05 +0100

zimoun <[email-masked]> writes:

> Hi Nicoló,
> Hum, I get these kind of messages:
>
> --8<---------------cut here---------------start------------->8---
> Internal error: encountered unexpected error in runtime:
> ErrorException("type UnionAll has no field size")
> jl_errorf at /tmp/guix-build-julia-1.5.3.drv-0/julia-1.5.3/src/rtutils.c:77
> --8<---------------cut here---------------end--------------->8---
>
> for julia-datastructures for instance.  Even if the build is fine and
> my small experiments seems correct.
>

I'd say it's a julia bug [fn:1].

can be reproduced with:

```julia
primitive type Foo{T} 32 end
foo(T, x) = (Core.bitcast(Foo{T}, x); x)
code_typed(foo, Tuple{Any, Int32})
```

We need to test this with julia 1.5.4 or 1.6.0 (the latter has been
released yesterday :D.  I had a build recipe for some version in
between 1.5.3 and 1.6.0, I'll check if it still works).  Before the guix
1.2.1 release, we might want to upgrade to 1.5.4 at least.

> Well, I have set this deprecation warning as a first commit in the v2.

Thanks!

I should have some time to re-check those later today

Nicolò

[fn:1] https://github.com/Juliaang/julia/issues/37532